package payloads.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import java.lang.reflect.AnnotatedElement;

@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
public @interface PayloadType {
    String JNDI = "jndi";
    String LOCAL = "local";

    String[] value() default {};

    public static class Utils {
        public static String[] getPayloadTypes(AnnotatedElement annotated) {
            PayloadType authors = annotated.getAnnotation(PayloadType.class);
            if (authors != null && authors.value() != null) {
                return authors.value();
            } else {
                return new String[0];
            }
        }
    }
}

